# coding: utf-8

"""
    Collibra Data Governance Center Core API

    <p>The Core REST API allows you to create your own integrations with Collibra Data Governance Center.</p><p><i>Create custom applications to help users get access to the right data.</i></p>  # noqa: E501

    The version of the OpenAPI document: 2.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from collibra_core import schemas  # noqa: F401


class NumericAttributeType(
    schemas.ComposedBase,
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Represents an attribute which holds a numeric value (either integer or floating point).
    """


    class MetaOapg:
        required = {
            "id",
            "resourceType",
        }
        
        @staticmethod
        def discriminator():
            return {
                'resourceType': {
                    'BooleanAttributeType': BooleanAttributeType,
                    'DateAttributeType': DateAttributeType,
                    'MultiValueListAttributeType': MultiValueListAttributeType,
                    'NumericAttributeType': NumericAttributeType,
                    'ScriptAttributeType': ScriptAttributeType,
                    'SingleValueListAttributeType': SingleValueListAttributeType,
                    'StringAttributeType': StringAttributeType,
                }
            }
        
        
        class all_of_1(
            schemas.DictSchema
        ):
        
        
            class MetaOapg:
                
                class properties:
                    statisticsEnabled = schemas.BoolSchema
                    isInteger = schemas.BoolSchema
                    __annotations__ = {
                        "statisticsEnabled": statisticsEnabled,
                        "isInteger": isInteger,
                    }
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["statisticsEnabled"]) -> MetaOapg.properties.statisticsEnabled: ...
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["isInteger"]) -> MetaOapg.properties.isInteger: ...
            
            @typing.overload
            def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
            
            def __getitem__(self, name: typing.Union[typing_extensions.Literal["statisticsEnabled", "isInteger", ], str]):
                # dict_instance[name] accessor
                return super().__getitem__(name)
            
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["statisticsEnabled"]) -> typing.Union[MetaOapg.properties.statisticsEnabled, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["isInteger"]) -> typing.Union[MetaOapg.properties.isInteger, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
            
            def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["statisticsEnabled", "isInteger", ], str]):
                return super().get_item_oapg(name)
            
        
            def __new__(
                cls,
                *args: typing.Union[dict, frozendict.frozendict, ],
                statisticsEnabled: typing.Union[MetaOapg.properties.statisticsEnabled, bool, schemas.Unset] = schemas.unset,
                isInteger: typing.Union[MetaOapg.properties.isInteger, bool, schemas.Unset] = schemas.unset,
                _configuration: typing.Optional[schemas.Configuration] = None,
                **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
            ) -> 'all_of_1':
                return super().__new__(
                    cls,
                    *args,
                    statisticsEnabled=statisticsEnabled,
                    isInteger=isInteger,
                    _configuration=_configuration,
                    **kwargs,
                )
        
        @classmethod
        @functools.lru_cache()
        def all_of(cls):
            # we need this here to make our import statements work
            # we must store _composed_schemas in here so the code is only run
            # when we invoke this method. If we kept this at the class
            # level we would get an error because the class level
            # code would be run when this module is imported, and these composed
            # classes don't exist yet because their module has not finished
            # loading
            return [
                AttributeType,
                cls.all_of_1,
            ]

    
    id: schemas.AnyTypeSchema
    resourceType: schemas.AnyTypeSchema

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'NumericAttributeType':
        return super().__new__(
            cls,
            *args,
            _configuration=_configuration,
            **kwargs,
        )

from collibra_core.model.attribute_type import AttributeType
from collibra_core.model.boolean_attribute_type import BooleanAttributeType
from collibra_core.model.date_attribute_type import DateAttributeType
from collibra_core.model.multi_value_list_attribute_type import MultiValueListAttributeType
from collibra_core.model.numeric_attribute_type import NumericAttributeType
from collibra_core.model.script_attribute_type import ScriptAttributeType
from collibra_core.model.single_value_list_attribute_type import SingleValueListAttributeType
from collibra_core.model.string_attribute_type import StringAttributeType
